/* 
  ParameterManager.h

  Barry McMullin <mcmullin@eeng.dcu.ie>
  16-OCT-1996

*/

#import <objectbase/SwarmObject.h>
#import <simtools.h>

@interface ParameterManager : SwarmObject {
  id probeDisplay;
  double catalystMobilityFactor;
  double productionProbability;
  double catalystDecayProbability;
  double link0MobilityFactor;
  double link1MobilityFactor;
  double link2MobilityFactor;
  double disintegrationProbability;
  double noBondingProbability;
  double chainInitiateProbability;
  double chainExtendProbability;
  double chainSpliceProbability;
  double absorptionProbability;
  double emissionProbability;
  double activeRepairProbability;
  double displaceProbability;
  double linkPromotionProbability;
  double substrateMobilityFactor;
  double holeMobilityFactor;
  double bondDecayProbability;
  BOOL chainInhibitBondFlag;
  BOOL catInhibitBondFlag;
  BOOL catInhibitDisintFlag;
  BOOL energeticMotionFlag;
  BOOL link0SmartMotionFlag;
  BOOL link1SmartMotionFlag;
  BOOL catSmartMotionFlag;
  BOOL acuteBondingFlag;
  unsigned timerKludge;
}

-(void) setCatalystMobilityFactor: (double) mobilityFactor;
-(double) getCatalystMobilityFactor;
-(void) setProductionProbability: (double) probability;
-(double) getProductionProbability;
-(void) setCatalystDecayProbability: (double) probability;
-(double) getCatalystDecayProbability;

-(void) setLink0MobilityFactor: (double) mobilityFactor;
-(double) getLink0MobilityFactor;
-(void) setLink1MobilityFactor: (double) mobilityFactor;
-(double) getLink1MobilityFactor;
-(void) setLink2MobilityFactor: (double) mobilityFactor;
-(double) getLink2MobilityFactor;
-(void) setChainInhibitBondFlag: (BOOL) value;
-(BOOL) getChainInhibitBondFlag;
-(void) setCatInhibitBondFlag: (BOOL) value;
-(BOOL) getCatInhibitBondFlag;
-(void) setCatInhibitDisintFlag: (BOOL) value;
-(BOOL) getCatInhibitDisintFlag;
-(void) setEnergeticMotionFlag: (BOOL) value;
-(BOOL) getEnergeticMotionFlag;
-(void) setAcuteBondingFlag: (BOOL) value;
-(BOOL) getAcuteBondingFlag;
-(void) setCatSmartMotionFlag: (BOOL) value;
-(BOOL) getCatSmartMotionFlag;
-(void) setLink0SmartMotionFlag: (BOOL) value;
-(BOOL) getLink0SmartMotionFlag;
-(void) setLink1SmartMotionFlag: (BOOL) value;
-(BOOL) getLink1SmartMotionFlag;
-(void) setDisintegrationProbability: (double) probability;
-(double) getDisintegrationProbability;
-(void) setNoBondingProbability: (double) probability;
-(double) getNoBondingProbability;
-(void) setChainInitiateProbability: (double) probability;
-(double) getChainInitiateProbability;
-(void) setChainExtendProbability: (double) probability;
-(double) getChainExtendProbability;
-(void) setChainSpliceProbability: (double) probability;
-(double) getChainSpliceProbability;
-(void) setAbsorptionProbability: (double) probability;
-(double) getAbsorptionProbability;
-(void) setEmissionProbability: (double) probability;
-(double) getEmissionProbability;
-(void) setActiveRepairProbability: (double) probability;
-(double) getActiveRepairProbability;
-(void) setDisplaceProbability: (double) probability;
-(double) getDisplaceProbability;
-(void) setLinkPromotionProbability: (double) probability;
-(double) getLinkPromotionProbability;

-(void) setSubstrateMobilityFactor: (double) mobilityFactor;
-(double) getSubstrateMobilityFactor;

-(void) setHoleMobilityFactor: (double) mobilityFactor;
-(double) getHoleMobilityFactor;

-(void) setBondDecayProbability: (double) probability;
-(double) getBondDecayProbability;

-(void) setTimerKludge: (unsigned) kludge;
-(unsigned) getTimerKludge;

-(void) apply;
-(void) slowdownKludge;

-saveToFileNamed: (char *) filename;
-loadFromFileNamed: (char *) filename;

@end
